<template>
  <v-container
    text-center
    color="secondary"
  >  
    <v-row v-if="displayVerifiedMessage">
      <v-col>
        <v-snackbar
          v-model="snackbar"
          top
          multi-line
          color="info"
          vertical
          :timeout="10000"
        >
          <div>
            {{ $t('snackbar1') }}
            <a :href="$t('profileLink')">
              " {{ $t('myProfile') }} "
            </a>
            {{ $t('snackbar2') }}
          </div>
          <v-btn
            color="info"
            elevation="0"
            @click="snackbar = false"
          >
            <v-icon
              color="primary"
            >
              mdi-close
            </v-icon>
          </v-btn>
        </v-snackbar>
      </v-col>
    </v-row>

    <v-row v-if="displayDeleteAccount">
      <v-col>
        <v-snackbar
          v-model="snackbar"
          top
          multi-line
          color="info"
          vertical
        >
          <div>
            {{ $t('snackbar-account-delete') }}
          </div>
          <v-btn
            color="info"
            elevation="0"
            @click="snackbar = false"
          >
            <v-icon
              color="primary"
            >
              mdi-close
            </v-icon>
          </v-btn>
        </v-snackbar>
      </v-col>
    </v-row>
    <v-row v-if="displayUnsubscribeEmail">
      <v-col>
        <v-snackbar
          v-model="snackbar"
          top
          multi-line
          color="info"
          vertical
        >
          <div>
            {{ displayUnsubscribeEmail }}
          </div>
          <v-btn
            color="info"
            elevation="0"
            @click="snackbar = false"
          >
            <v-icon
              color="primary"
            >
              mdi-close
            </v-icon>
          </v-btn>
        </v-snackbar>
      </v-col>
    </v-row>

    <!-- Title and subtitle -->
    <v-row
      align="center"
      class="mt-5"
      justify="center"
    >
      <v-col
        cols="12"
        xl="6"
        lg="9"
        md="12"
        class="text-center"
      >
        <h1>{{ $t('title') }}</h1>
        <v-col v-if="additionalTextDisplay">
          <h3 v-html="$t('subtitle')" />
        </v-col>
      </v-col>
    </v-row>
    <search
      :geo-search-url="geoSearchUrl"
      :geo-complete-results-order="geoCompleteResultsOrder"
      :geo-complete-palette="geoCompletePalette"
      :geo-complete-chip="geoCompleteChip"
      :user="user"
      :regular="regular"
      :punctual-date-optional="punctualDateOptional"
      :publish-button-always-active="publishButtonAlwaysActive"
      :date-time-picker="dateTimePicker"
    />
    <v-row
      class="mt-6"
      dense
      justify="center"
    >
      <v-col
        align="center"
        cols="6"
      >
        <v-btn
          rounded
          color="success"
          :href="$t('relayPoints.route')"
          dark
          class="elevation-0"
        >
          {{ $t('relayPoints.label') }}
        </v-btn>
      </v-col>
    </v-row>

    <v-row
      align="center"
      class="mt-5"
      justify="center"
    >
      <v-col
        cols="12"
      >
        <home-content
          :community-display="communityDisplay"
          :event-display="eventDisplay"
          :solidary-display="solidaryDisplay"
          :additional-text-display="additionalTextDisplay"
          :url-mobile="mobileUrl"
          :user-id="(user && user.id) ? user.id : null"
        />
      </v-col>
    </v-row>
    <m-dialog
      v-if="isEecAvailable" 
      :eec-instance="eecInstance"
    />
  </v-container>
</template>

<script>
import {merge} from "lodash";
import {messages_en, messages_fr, messages_eu} from "@translations/components/home/Home/";
import {messages_client_en, messages_client_fr, messages_client_eu} from "@clientTranslations/components/home/Home/";
import Search from "@clientComponents/carpool/search/Search";
import HomeContent from "@clientComponents/home/HomeContent";
import MDialog from "@components/utilities/MDialog";


let MessagesMergedEn = merge(messages_en, messages_client_en);
let MessagesMergedEu = merge(messages_eu, messages_client_eu);
let MessagesMergedFr = merge(messages_fr, messages_client_fr);

export default {
  i18n: {
    messages: {
      'en': MessagesMergedEn,
      'eu': MessagesMergedEu,
      'fr': MessagesMergedFr
    }
  },
  components: {
    Search,
    HomeContent,
    MDialog
  },
  props: {
    geoSearchUrl: {
      type: String,
      default: ""
    },
    user: {
      type: Object,
      default: null
    },
    regular: {
      type: Boolean,
      default: false
    },
    punctualDateOptional: {
      type: Boolean,
      default: false
    },
    debug: {
      type: Boolean,
      default: false
    },
    position: {
      type: String,
      default: ""
    },
    transitionName: {
      type: String,
      default: ""
    },
    solidaryDisplay: {
      type: Boolean,
      default: false
    },
    eventDisplay: {
      type: Boolean,
      default: false
    },
    displayDeleteAccount: {
      type: Number,
      default: 0
    },
    displayUnsubscribeEmail: {
      type: String,
      default: ""
    },
    communityDisplay: {
      type: Boolean,
      default: false
    },
    additionalTextDisplay: {
      type: Boolean,
      default: false
    },
    publishButtonAlwaysActive:{
      type: Boolean,
      default:false
    },
    // params to add to the publish and search routes
    params: {
      type: Object,
      default: null
    },
    urlMobile: {
      type: String,
      default: null
    },
    informativeMessageActive: {
      type: Boolean,
      default: false
    },
    informativeMessageText: {
      type: String,
      default: null
    },
    geoCompleteResultsOrder: {
      type: Array,
      default: null
    },
    geoCompletePalette: {
      type: Object,
      default: () => ({})
    },
    geoCompleteChip: {
      type: Boolean,
      default: false
    },
    dateTimePicker: {
      type: Boolean,
      default: false
    },
    eecInstance: {
      type: Object,
      default: () => ({})
    }
  },
  data () {
    return {
      snackbar: true,
      displayVerifiedMessage: false,
      mobileUrl: this.urlMobile
    }
  },
  computed: {
    isEecAvailable() {
      return this.eecInstance && this.eecInstance.available;
    }
  },
  mounted() {
    this.checkVerifiedPhone();
  },
  methods:{
    checkVerifiedPhone() {
      if (this.user !==null && this.user.telephone !== null) {
        this.displayVerifiedMessage = this.user.phoneValidatedDate ? false : true;
      }
    }
  }
};
</script>